# Copyright 2007, TIG
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided this notice 
# appears in all copies.
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------
# Name        : Explode2Groups.rb
# Description : A script that adds a Context-menu - "Explode to Groups"
# Context Menu: Explode to Groups
# Usage       : Select a Group.  Right-click.  
#               Context-menu "Explode to Groups".
#               All connected Geometry is grouped into separate Groups.
# Type        : Tool
# Author      : TIG
# Verison     :	1.1	20071216	Second issue, without Bugsplats.
#-----------------------------------------------------------------------
require 'sketchup.rb'
###
def explode2Groups
  model=Sketchup.active_model
  model.start_operation"Explode to Groups"
  group=model.selection[0]; entities=group.entities
  edges=[]; entities.each{|e|edges.push(e)if e.typename=="Edge"}
  allco=[]; edges.each{|e|allco.push(e.all_connected)}; allco.uniq!
  group.explode if group.valid?
  allco.each{|e|model.active_entities.add_group(e)}
  model.commit_operation
end#def
### menu ------------------------------
if not file_loaded?("Explode2Groups.rb")
  UI.add_context_menu_handler do |menu|
    if Sketchup.active_model.selection[0].typename=="Group"
	  menu.add_separator
      menu.add_item("Explode to Groups"){explode2Groups}
    end #if ok
  end #do menu
end
file_loaded("Explode2Groups.rb")
###